local addonName = "Accounter"

local HOUR = 3600
local DAY = 86400
local WEEK = 604800

local session = {
  income = {},
  expenses = {}
}

local defaults = {
  settings = {
    showGUI = true,
    showBank = true
  },
  accounts = {
    income = {},
    expenses = {}
  },
  week = {},
--  year = {}
}
--[[
local accountMeta = {
  __index = function (t, key)
    if key == "total" then
      local sum = 0
      for _, value in pairs(t) do
        sum = sum + value
      end
      return sum
    else
      return rawget(t, key)
    end
  end
}
]]
--setmetatable(session.income, accountMeta)

local variables = nil
local accounts = nil
local today = nil
local yesterday = nil
local accw = nil
local lastRow = {}
local tzone = math.floor(GetFormattedTime()/10000)-math.floor((GetTimeStamp()%DAY)/HOUR)

--local timestamp = GetTimeStamp()
local weekdayNums = {
  sunday = 0,
  monday = 1,
  tuesday = 2,
  wednesday = 3,
  thursday = 4,
  friday = 5,
  saturday = 6
}

local reasonNames = {
  [CURRENCY_CHANGE_REASON_LOOT] = "Loot",
  [CURRENCY_CHANGE_REASON_VENDOR] = "Merchant",
  [CURRENCY_CHANGE_REASON_MAIL] = "Mail",
  [CURRENCY_CHANGE_REASON_TRADE] = "Trade",
  [CURRENCY_CHANGE_REASON_QUESTREWARD] = "Quest",
  [CURRENCY_CHANGE_REASON_CONVERSATION] = "NPC Conversation",
  [CURRENCY_CHANGE_REASON_ACTION] = "ACTION",
  [CURRENCY_CHANGE_REASON_COMMAND] = "COMMAND",
  [CURRENCY_CHANGE_REASON_BAGSPACE] = "Bag Upgrade",
  [CURRENCY_CHANGE_REASON_BANKSPACE] = "Bank Upgrade",
  [CURRENCY_CHANGE_REASON_SOULWEARY] = "SOULWEARY",
  [CURRENCY_CHANGE_REASON_BATTLEGROUND] = "BATTLEGROUND",
  [CURRENCY_CHANGE_REASON_KILL] = "KILL",
  [CURRENCY_CHANGE_REASON_KEEP_REWARD] = "Keep Reward",
  [CURRENCY_CHANGE_REASON_KEEP_UPGRADE] = "Keep Upgrade",
  [CURRENCY_CHANGE_REASON_DECONSTRUCT] = "DECONSTRUCT",
  [CURRENCY_CHANGE_REASON_SOUL_HEAL] = "SOUL_HEAL",
  [CURRENCY_CHANGE_REASON_TRAVEL_GRAVEYARD] = "Wayshrine",
  [CURRENCY_CHANGE_REASON_CASH_ON_DELIVERY] = "Cash on Delivery",
  [CURRENCY_CHANGE_REASON_MEDAL] = "MEDAL",
  [CURRENCY_CHANGE_REASON_ABILITY_UPGRADE_PURCHASE] = "ABILITY_UPGRADE_PURCHASE",
  [CURRENCY_CHANGE_REASON_HOOKPOINT_STORE] = "HOOKPOINT_STORE",
  [CURRENCY_CHANGE_REASON_CRAFT] = "CRAFT",
  [CURRENCY_CHANGE_REASON_STABLESPACE] = "Stablespace",
  [CURRENCY_CHANGE_REASON_ACHIEVEMENT] = "Achievement",
  [CURRENCY_CHANGE_REASON_REWARD] = "REWARD",
  [CURRENCY_CHANGE_REASON_FEED_MOUNT] = "Mount Feeding",
  [CURRENCY_CHANGE_REASON_VENDOR_REPAIR] = "Repair",
  [CURRENCY_CHANGE_REASON_TRAIT_REVEAL] = "TRAIT_REVEAL",
  [CURRENCY_CHANGE_REASON_TRADINGHOUSE_PURCHASE] = "Tradehouse Purchase",
  [CURRENCY_CHANGE_REASON_TRADINGHOUSE_REFUND] = "Tradehouse Refund",
  [CURRENCY_CHANGE_REASON_TRADINGHOUSE_LISTING] = "Tradehouse Listing",
  [CURRENCY_CHANGE_REASON_REFORGE] = "REFORGE",
  [CURRENCY_CHANGE_REASON_PLAYER_INIT] = "PLAYER_INIT",
  [CURRENCY_CHANGE_REASON_RECIPE] = "RECIPE",
  [CURRENCY_CHANGE_REASON_CONSUME_FOOD_DRINK] = "CONSUME_FOOD_DRINK",
  [CURRENCY_CHANGE_REASON_CONSUME_POTION] = "CONSUME_POTION",
  [CURRENCY_CHANGE_REASON_HARVEST_REAGENT] = "HARVEST_REAGENT",
  [CURRENCY_CHANGE_REASON_KEEP_REPAIR] = "Keep Repair",
  [CURRENCY_CHANGE_REASON_PVP_RESURRECT] = "PVP_RESURRECT",
  [CURRENCY_CHANGE_REASON_BANK_DEPOSIT] = "Bank Deposit",
  [CURRENCY_CHANGE_REASON_BANK_WITHDRAWAL] = "Bank Withdrawl",
  [CURRENCY_CHANGE_REASON_RESPEC_SKILLS] = "Skill Respec",
  [CURRENCY_CHANGE_REASON_RESPEC_ATTRIBUTES] = "Attribute Respec",
  [CURRENCY_CHANGE_REASON_RESEARCH_TRAIT] = "RESEARCH_TRAIT",
  [CURRENCY_CHANGE_REASON_STUCK] = "Unstucked"
}

local function CreateRow(container, rowNum, column, previousRow)
  local row = {}
  local label = WINDOW_MANAGER:CreateControl("Accw"..column..rowNum.."Label", container, CT_LABEL)
  local value = WINDOW_MANAGER:CreateControl("Accw"..column..rowNum.."Value", container, CT_LABEL)
  label:SetFont("ZoFontGame")
  value:SetFont("ZoFontGame")
  if rowNum == 1 then
    label:SetAnchor(TOPRIGHT, previousRow, BOTTOM, -2, 0)
    value:SetAnchor(TOPLEFT, previousRow, BOTTOM, 2, 0)
  else
    label:SetAnchor(TOPRIGHT, previousRow.label, BOTTOMRIGHT, 0, 0)
    value:SetAnchor(TOPLEFT, previousRow.value, BOTTOMLEFT, 0, 0)
  end
--  label:SetAnchor(BOTTOMRIGHT, row, BOTTOM, 0, 0)

--  row:SetAnchor(TOP, previousRow, BOTTOM, 0, 0)
--  row:SetFont("ZoFontGame")
  
  row.label = label
  row.value = value
  lastRow[column] = rowNum
  
  row.SetHidden = function(row, hidden)
    row.label:SetHidden(hidden)
    row.value:SetHidden(hidden)
  end
--  d(column..lastRow[column])
  return row
end

local function PopulateBlock(block, account)
  local lastRow = block.title
  local row = 1
  local total = 0
  block.rows = block.rows or {}

  for reason, value in pairs(account) do
--    if (reason ~= CURRENCY_CHANGE_REASON_BANK_WITHDRAWAL) and (reason ~= CURRENCY_CHANGE_REASON_BANK_DEPOSIT) then
      block.rows[row] = block.rows[row] or CreateRow(block, row, block.titlename, lastRow)
      block.rows[row].label:SetText((reasonNames[reason] or ("Unknown Reason "..reason))..":")
  --    block.rows[row].label:SetHidden(false)
      block.rows[row].value:SetText(value)
  --    block.rows[row].value:SetHidden(false)
      block.rows[row]:SetHidden(false)
      lastRow = block.rows[row]
      row = row + 1
      total = total + value
--    end
  end
  
  block.numVisible = row-1
  
  for i = row, #block.rows do
    block.rows[i]:SetHidden(true)
--    block.rows[i].label:SetHidden(true)
--    block.rows[i].value:SetHidden(true)
  end
  
  block.totalValue = total
  block.total:SetText("Total: "..total)
end

local function CreateBlock(window, name)
  local block = WINDOW_MANAGER:CreateControl("Accw"..name, window, CT_CONTROL)

  block.title = WINDOW_MANAGER:CreateControl("Accw"..name.."Title", block, CT_LABEL)
  block.title:SetAnchor(TOP, block, TOP, 0, 0)
  block.title:SetFont("ZoFontAnnounceMedium")
  block.title:SetText(name)
  
  block.titlename = name
  
  block.total = WINDOW_MANAGER:CreateControl("Accw"..name.."Total", block, CT_LABEL)
  block.total:SetAnchor(BOTTOM, block, BOTTOM, 0, 0)
  block.total:SetFont("ZoFontAnnounceMedium")
  
  block.numVisible = 0
  
  block.SetTitle = function(block, title)
    block.title:SetText(title)
    block.titlename = title
  end
  
  return block

end

local function CreateAccounterWindow()
  local window = WINDOW_MANAGER:CreateTopLevelWindow("AccounterWindow")
  window:SetHidden(true)
  window:SetMovable(true)
  window:SetMouseEnabled(true)
  window:SetDimensions(550, 400)
  window:SetAnchor(CENTER, GuiRoot, CENTER, 0, 0)
  
  window.bg = WINDOW_MANAGER:CreateControlFromVirtual("AccwBg", window, "ZO_DefaultBackdrop")
  window.bg:SetAnchorFill(window)
  
  window.closeButton = WINDOW_MANAGER:CreateControl("AccwCloseBtn", window, CT_BUTTON)
--  window.closeButton = WINDOW_MANAGER:CreateControlFromVirtual("AccwCloseBtn", window, "ZO_ScrollContainer")
  window.closeButton:SetAnchor(TOPRIGHT, window, TOPRIGHT, -5, 4)
  window.closeButton:SetNormalTexture("/esoui/art/buttons/decline_up.dds")
  window.closeButton:SetMouseOverTexture("/esoui/art/buttons/decline_over.dds")
  window.closeButton:SetMouseOverBlendMode(TEX_BLEND_MODE_ADD)
  window.closeButton:SetPressedTexture("/esoui/art/buttons/decline_down.dds")
  window.closeButton:SetDimensions(20, 20)
  window.closeButton:SetHandler("OnClicked", function(closeButton) accw:SetHidden(true) end)
  
--  window.title = WINDOW_MANAGER:CreateControlFromVirtual("AccwTitle", window, "ZO_Options_SectionTitle")
  window.title = WINDOW_MANAGER:CreateControl("AccwTitle", window, CT_LABEL)
  window.title:SetAnchor(TOP, window, TOP, 0, 8)
  window.title:SetFont("ZoFontAnnounceMedium")
  window.title:SetText("ACCOUNTER")
  
  window.accounts = CreateBlock(window, "Accounts")
  window.accounts:SetAnchor(TOPLEFT, window, TOPLEFT, 4, 34)
  window.accounts:SetAnchor(TOPRIGHT, window, TOPRIGHT, -4, 34)

  window.accounts.income = CreateBlock(window.accounts, "Income")
  window.accounts.income:SetAnchor(TOPLEFT, window.accounts, TOPLEFT, 0, 34)
  window.accounts.income:SetAnchor(BOTTOMRIGHT, window.accounts, BOTTOM, 0, -34)
 
  window.accounts.expenses = CreateBlock(window.accounts, "Expenses")
  window.accounts.expenses:SetAnchor(TOPLEFT, window.accounts, TOP, 0, 34)
  window.accounts.expenses:SetAnchor(BOTTOMRIGHT, window.accounts, BOTTOMRIGHT, -4, -34)

  window.bank = CreateBlock(window, "Bank")
  window.bank:SetAnchor(TOPLEFT, window.accounts, BOTTOMLEFT, 0, 4)
  window.bank:SetAnchor(TOPRIGHT, window.accounts, BOTTOMRIGHT, 0, 4)

  window.bank.withdrawals = CreateBlock(window.bank, "Withdrawals")
  window.bank.withdrawals:SetAnchor(TOPLEFT, window.bank, TOPLEFT, 0, 34)
  window.bank.withdrawals:SetAnchor(BOTTOMRIGHT, window.bank, BOTTOM, 0, -34)
 
  window.bank.deposits = CreateBlock(window.bank, "Deposits")
  window.bank.deposits:SetAnchor(TOPLEFT, window.bank, TOP, 0, 34)
  window.bank.deposits:SetAnchor(BOTTOMRIGHT, window.bank, BOTTOMRIGHT, -4, -34)

  
  return window
end


local function PopulateWindow(dpAccounts, title)

  accw.accounts:SetTitle((title or "").." Accounts")
  
  local income = {}
  local withdrawals = {}
  local expenses = {}
  local deposits = {}
  
  for reason, value in pairs(dpAccounts.income) do
    if (reason == CURRENCY_CHANGE_REASON_BANK_WITHDRAWAL) then
      withdrawals[reason] = value
    else
      income[reason] = value
    end
  end

  for reason, value in pairs(dpAccounts.expenses) do
    if (reason == CURRENCY_CHANGE_REASON_BANK_DEPOSIT) then
      deposits[reason] = value
    else
      expenses[reason] = value
    end
  end  
  
  PopulateBlock(accw.accounts.income, income)
  PopulateBlock(accw.accounts.expenses, expenses)
  
  local total = accw.accounts.income.totalValue-accw.accounts.expenses.totalValue
  accw.accounts.total:SetText("Totals: "..total)
  accw.accounts:SetHeight(140 + math.max(accw.accounts.income.numVisible, accw.accounts.expenses.numVisible)*20)
  
  PopulateBlock(accw.bank.withdrawals, withdrawals)
  PopulateBlock(accw.bank.deposits, deposits)
  
  total = accw.bank.withdrawals.totalValue-accw.bank.deposits.totalValue
  accw.bank.total:SetText("Totals: "..total)
  accw.bank:SetHeight(140 + math.max(accw.bank.withdrawals.numVisible, accw.bank.deposits.numVisible)*20)
  
  accw.bank:SetHidden(not variables.settings.showBank)
  
  accw:SetHeight(44 + accw.accounts:GetHeight() + (accw.bank:IsControlHidden() and 0 or accw.bank:GetHeight()))
  accw:SetHidden(false)
end

-- Sunday = 0, Saturday = 6
local function GetWeekday(localTimestamp)
  return math.floor((((localTimestamp or GetLocalTimeStamp())+345600)%WEEK)/DAY)
end

local function GetMonth(dateString)
  return string.sub(dateString, 1, 2)
end

local function GetYear(dateString)
  return string.sub(dateString, 7, 8)
end

local function GetLocalTimeStamp(timestamp)
  return (timestamp or GetTimeStamp())+(tzone*HOUR)
end

local function GetFixedDate(timestamp)
  return GetDateStringFromTimestamp(timestamp or GetTimeStamp())
end



local currentDate = GetFixedDate()
local currentDay = GetWeekday(GetLocalTimeStamp())

local function CheckDayChange()
  local eventDate = GetFixedDate()
--  d("checkdaychange, eventDate: "..eventDate)
--  d("checkdaychange, currentDate: "..currentDate)

  if eventDate ~= currentDate then
    d("switchingday")
    local timestamp = GetLocalTimeStamp()
    currentDay = GetWeekday(timestamp)
    variables.week[currentDay] = {
      income = {},
      expenses = {},
      recordDate = eventDate,
      timestamp = timestamp
    }
    currentDate = eventDate
    yesterday = today
    today = variables.week[currentDay]
--    yesterday = variables.week[(currentDay-1)%7]
  end
  
end

local function OnMoneyUpdate(eventCode, newMoney, oldMoney, reason)
  CheckDayChange()
  
  local diff = newMoney-oldMoney
  
  if diff == 0 or reason == CURRENCY_CHANGE_REASON_PLAYER_INIT then return end

  if diff > 0 then
    session.income[reason] = (session.income[reason] or 0) + diff
    accounts.income[reason] = (accounts.income[reason] or 0) + diff
    today.income[reason] = (today.income[reason] or 0) + diff
  else
    session.expenses[reason] = (session.expenses[reason] or 0) - diff
    accounts.expenses[reason] = (accounts.expenses[reason] or 0) - diff
    today.expenses[reason] = (today.expenses[reason] or 0) - diff
  end

end


local function PrintBalance(account)
  if account then
    local sum = 0
    for reason, balance in pairs(account) do
      sum = sum + balance
      d((reasonNames[reason] or ("Unknown Reason "..reason))..": "..balance)
    end
    d("|c00FFFFTotal|r: "..sum)
--    d(" ")
  else
    d("No records")
  end
end

local function PrintBalances(dpAccounts, title)
  d("|c00FF00"..title.." Income|r")
  PrintBalance(dpAccounts.income)
  d("|cFF0000"..title.." Expenses|r")
  PrintBalance(dpAccounts.expenses)
end

local function SlashCommandHandler(args)
  CheckDayChange()
  if weekdayNums[args] then
    local title = string.gsub(args, '^%a', string.upper, 1).."'s"
    PrintBalances(variables.week[weekdayNums[args]], title)
    if variables.settings.showGUI then PopulateWindow(variables.week[weekdayNums[args]], title) end
  elseif args == "session" then
    PrintBalances(session, "Session")
    if variables.settings.showGUI then PopulateWindow(session, "Session") end
  elseif args == "today" then
--    d("today: "..today.recordDate)
    PrintBalances(today, "Today's")
    if variables.settings.showGUI then PopulateWindow(today, "Today's") end
  elseif args == "yesterday" then
--    d("yesterday: "..yesterday.recordDate)
    PrintBalances(yesterday, "Yesterday's")
    if variables.settings.showGUI then PopulateWindow(yesterday, "Yesterday's") end
  elseif args == "hide" then
    accw:SetHidden(true)
  elseif args == "guitoggle" then
    variables.settings.showGUI = not variables.settings.showGUI
    d("Showing GUI is: " .. (variables.settings.showGUI and "ON" or "OFF"))
  elseif args == "banktoggle" then
    variables.settings.showBank = not variables.settings.showBank
    d("Showing Bank is: " .. (variables.settings.showBank and "ON" or "OFF"))
  else
    PrintBalances(accounts, "Alltime")
    if variables.settings.showGUI then PopulateWindow(accounts) end
--    d("Previousday:"..(currentDay-1)%7)
--    d("weekday: "..currentDay)
--    d("date: "..currentDate)
--    d("fixedyesterdaystamp: "..GetFixedDate(GetTimeStamp()-DAY))
  end
end


local function AddonInitialized(eventCode, addon)

  if (addon ~= addonName) then return end
  
  variables = ZO_SavedVars:New(addonName, 1, nil, defaults)
  accounts = variables.accounts
  
  if (not variables.week[currentDay]) or variables.week[currentDay].recordDate ~= currentDate then
    variables.week[currentDay] = {
      income = {},
      expenses = {},
      recordDate = currentDate,
      timestamp = GetLocalTimeStamp()
    }
  end
  today = variables.week[currentDay]
  
  local previousDay = (currentDay-1)%7
  
  if (not variables.week[previousDay]) or variables.week[previousDay].recordDate ~= GetFixedDate(GetTimeStamp()-DAY) then
    variables.week[previousDay] = {
      income = {},
      expenses = {},
      recordDate = GetFixedDate(GetTimeStamp()-DAY),
      timestamp = GetLocalTimeStamp()-DAY
    }
  end
  yesterday = variables.week[previousDay]
--  setmetatable(today.income, accountMeta)

  accw = CreateAccounterWindow()

  EVENT_MANAGER:RegisterForEvent(addonName, EVENT_MONEY_UPDATE, OnMoneyUpdate)
--  EVENT_MANAGER:RegisterForEvent(addonName, EVENT_ALLIANCE_POINT_UPDATE, OnAPUpdate)
  SLASH_COMMANDS["/accounter"] = SlashCommandHandler
end

EVENT_MANAGER:RegisterForEvent(addonName,EVENT_ADD_ON_LOADED,AddonInitialized)
